use super::series::{add::AddSeries, SeriesList};
use leptos::*;
use leptos_router::*;

#[component]
pub fn HomePage() -> impl IntoView {
    let add_series = create_server_action::<AddSeries>();

    provide_context(add_series);

    view! {
        <h1 class="mt-3 mb-5">"What We're Watching"</h1>
        <div class="row">
            <div class="col">
                <SeriesList />
            </div>
            <div class="col">
                <Outlet />
            </div>
        </div>
    }
}
